# Bitsy Bundler!

This is a tool that lets you download a bunch of hack/plugin files for the game engine [Bitsy](https://ledoux.itch.io/bitsy) to extend the engine's functionality. It compiles them into a single js file that you can easily include in your game HTML file without making it, like, really really long.

If you're a programmer, think of it like bundler for ruby, or npm/yarn/etc. for node, or composer for php, or like, whatever else, except it doesn't do nested dependencies.

System Requirements:

* Some relatively recent version of PHP, because I could not tell you what happens if you use like PHP 4 or something. If you don't have a version of PHP, [look at this guide](https://www.php.net/manual/en/install.php).
* A command line program you like
* A text editor I guess?

## How to use

1. Download Bitsy Bundler (either from source control or as a zip file), and put the files into your project folder.
2. Edit your hacks.json file:
   * Add any additional hack repositories you might be drawing from, in the format user/repo/path/to/folder.
   * If you have any local hack files, change the "local" value to be the relative path to that directory.
   * Add the names of any hack files (minus the "js") to the "hacks" array. You can also add full-on URLs in here if you have hacks from other sources.
3. Run `php bundler.php` from your project folder on the command line.
4. This will generate a hacks.js file, alert you to any issues you might have encountered (missing sources, for example), and also give you a copy-paste line to put into your Bitsy HTML file, if you haven't already.

Anyway that's it. This is probably still a little arcane for non-programmers, potentially, so I'm open to any suggestions as far as making it more user-friendly/adding more options/etc.

If you really don't want to deal with a terminal interface, there's [Borksy](https://ayolland.itch.io/borksy)! This is just for power users and my highly specific desire to easily add and swap out hacks without having to generate a new game template.

## Future Improvements?

There's not like a roadmap or anything but there's a few things I do already have in mind.

* Better source management
* Option to minify hacks
* Option to keep hacks in separate files
* Version-based caching for speed?
* Better user/friendliness (interactive hacks.json file generation?)

## <3

If you get use out of this, obviously it's free! But on account of I'm presently freelance I appreciate tips, either via itch.io purchase or via [ko-fi](https://ko-fi.com/veryroundbird).
